var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Updux_localInitial, _Updux_localActions, _Updux_localMutations, _Updux_defaultMutation, _Updux_subduxes, _Updux_name, _Updux_actions, _Updux_initialState, _Updux_localSelectors, _Updux_selectors, _Updux_localEffects, _Updux_localReactions;
import * as R from 'remeda';
import { configureStore, } from '@reduxjs/toolkit';
import { buildActions } from './buildActions.js';
import { buildInitial } from './initial.js';
import { buildReducer } from './reducer.js';
import { augmentGetState, augmentMiddlewareApi, buildEffectsMiddleware, } from './effects.js';
import { produce } from 'immer';
export default class Updux {
    constructor(config) {
        var _a, _b, _c;
        _Updux_localInitial.set(this, void 0);
        _Updux_localActions.set(this, void 0);
        _Updux_localMutations.set(this, []);
        _Updux_defaultMutation.set(this, void 0);
        _Updux_subduxes.set(this, void 0);
        _Updux_name.set(this, void 0);
        _Updux_actions.set(this, void 0);
        _Updux_initialState.set(this, void 0);
        _Updux_localSelectors.set(this, void 0);
        _Updux_selectors.set(this, void 0);
        _Updux_localEffects.set(this, []);
        _Updux_localReactions.set(this, []);
        // TODO check that we can't alter the initialState after the fact
        __classPrivateFieldSet(this, _Updux_localInitial, (_a = config.initialState) !== null && _a !== void 0 ? _a : {}, "f");
        __classPrivateFieldSet(this, _Updux_localActions, (_b = config.actions) !== null && _b !== void 0 ? _b : {}, "f");
        __classPrivateFieldSet(this, _Updux_subduxes, (_c = config.subduxes) !== null && _c !== void 0 ? _c : {}, "f");
        __classPrivateFieldSet(this, _Updux_actions, buildActions(__classPrivateFieldGet(this, _Updux_localActions, "f"), __classPrivateFieldGet(this, _Updux_subduxes, "f")), "f");
        __classPrivateFieldSet(this, _Updux_initialState, buildInitial(__classPrivateFieldGet(this, _Updux_localInitial, "f"), __classPrivateFieldGet(this, _Updux_subduxes, "f")), "f");
        __classPrivateFieldSet(this, _Updux_localSelectors, config.selectors, "f");
        const basedSelectors = R.mergeAll(Object.entries(__classPrivateFieldGet(this, _Updux_subduxes, "f"))
            .filter(([slice, { selectors }]) => selectors)
            .map(([slice, { selectors }]) => R.mapValues(selectors, (s) => (state = {}) => {
            return s(state === null || state === void 0 ? void 0 : state[slice]);
        })));
        __classPrivateFieldSet(this, _Updux_selectors, R.merge(basedSelectors, __classPrivateFieldGet(this, _Updux_localSelectors, "f")), "f");
    }
    get actions() {
        return __classPrivateFieldGet(this, _Updux_actions, "f");
    }
    // TODO memoize?
    get initialState() {
        return __classPrivateFieldGet(this, _Updux_initialState, "f");
    }
    get effects() {
        return [
            ...__classPrivateFieldGet(this, _Updux_localEffects, "f"),
            ...Object.entries(__classPrivateFieldGet(this, _Updux_subduxes, "f")).flatMap(([slice, { effects }]) => {
                if (!effects)
                    return [];
                return effects.map((effect) => (api) => effect(Object.assign(Object.assign({}, api), { getState: () => api.getState()[slice] })));
            }),
        ];
    }
    get reactions() {
        return [
            ...__classPrivateFieldGet(this, _Updux_localReactions, "f"),
            ...Object.entries(__classPrivateFieldGet(this, _Updux_subduxes, "f")).flatMap(([slice, { reactions }]) => reactions.map((r) => (api, unsub) => r(Object.assign(Object.assign({}, api), { getState: () => api.getState()[slice] }), unsub))),
        ];
    }
    createStore(options = {}) {
        const preloadedState = options.preloadedState;
        const effects = buildEffectsMiddleware(this.effects, this.actions, this.selectors);
        const store = configureStore({
            reducer: this.reducer,
            preloadedState,
            middleware: [effects],
        });
        const dispatch = store.dispatch;
        for (const a in this.actions) {
            dispatch[a] = (...args) => {
                const action = this.actions[a](...args);
                dispatch(action);
                return action;
            };
        }
        store.getState = augmentGetState(store.getState, this.selectors);
        for (const reaction of this.reactions) {
            let unsub;
            const r = reaction(store);
            unsub = store.subscribe(() => r(unsub));
        }
        store.actions = this.actions;
        store.selectors = this.selectors;
        return store;
    }
    get selectors() {
        return __classPrivateFieldGet(this, _Updux_selectors, "f");
    }
    // TODO memoize this sucker
    get reducer() {
        return buildReducer(this.initialState, __classPrivateFieldGet(this, _Updux_localMutations, "f"), __classPrivateFieldGet(this, _Updux_defaultMutation, "f"), __classPrivateFieldGet(this, _Updux_subduxes, "f"));
    }
    addMutation(matcher, mutation, terminal = false) {
        if (typeof matcher === 'function' && matcher.match) {
            // matcher, matcher man...
            matcher = matcher.match;
        }
        const immerMutation = (...args) => produce(mutation(...args));
        __classPrivateFieldGet(this, _Updux_localMutations, "f").push({
            terminal,
            matcher,
            mutation: immerMutation,
        });
    }
    addDefaultMutation(mutation, terminal = false) {
        __classPrivateFieldSet(this, _Updux_defaultMutation, { mutation, terminal }, "f");
    }
    addEffect(...args) {
        let effect;
        if (args.length === 1) {
            effect = args[0];
        }
        else {
            const [actionCreator, originalEffect] = args;
            const test = actionCreator.hasOwnProperty('match')
                ? actionCreator.match
                : actionCreator;
            effect = (api) => (next) => {
                const e = originalEffect(api)(next);
                return (action) => {
                    const func = test(action) ? e : next;
                    return func(action);
                };
            };
        }
        __classPrivateFieldGet(this, _Updux_localEffects, "f").push(effect);
        return effect;
    }
    get effectsMiddleware() {
        return buildEffectsMiddleware(this.effects, this.actions, this.selectors);
    }
    addReaction(reaction) {
        let previous;
        const memoized = (api) => {
            api = augmentMiddlewareApi(api, this.actions, this.selectors);
            const r = reaction(api);
            return (unsub) => {
                const state = api.getState();
                if (state === previous)
                    return;
                let p = previous;
                previous = state;
                r(state, p, unsub);
            };
        };
        __classPrivateFieldGet(this, _Updux_localReactions, "f").push(memoized);
    }
    // internal method REMOVE
    subscribeTo(store, subscription) {
        const localStore = augmentMiddlewareApi(Object.assign(Object.assign({}, store), { subscribe: (subscriber) => this.subscribeTo(store, subscriber) }), this.actions, this.selectors);
        const subscriber = subscription(localStore);
        let previous;
        let unsub;
        const memoSub = () => {
            const state = store.getState();
            if (state === previous)
                return;
            let p = previous;
            previous = state;
            subscriber(state, p, unsub);
        };
        return store.subscribe(memoSub);
    }
}
_Updux_localInitial = new WeakMap(), _Updux_localActions = new WeakMap(), _Updux_localMutations = new WeakMap(), _Updux_defaultMutation = new WeakMap(), _Updux_subduxes = new WeakMap(), _Updux_name = new WeakMap(), _Updux_actions = new WeakMap(), _Updux_initialState = new WeakMap(), _Updux_localSelectors = new WeakMap(), _Updux_selectors = new WeakMap(), _Updux_localEffects = new WeakMap(), _Updux_localReactions = new WeakMap();
